//
// Copyright (C) 2006, NinjaTrader LLC <ninjatrader@ninjatrader.com>.
// NinjaTrader reserves the right to modify or overwrite this NinjaScript component with each release.
//

#region Using declarations
using System;
using System.ComponentModel;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Xml.Serialization;
using NinjaTrader.Data;
using NinjaTrader.Gui.Chart;
#endregion

#region NinjaScript generated code. Neither change nor remove.
// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    public partial class Indicator : IndicatorBase
    {
        private PriceLine[] cachePriceLine = null;

        private static PriceLine checkPriceLine = new PriceLine();

        /// <summary>
        /// Price Line
        /// </summary>
        /// <returns></returns>
        public PriceLine PriceLine()
        {
            return PriceLine(Input);
        }

        /// <summary>
        /// Price Line
        /// </summary>
        /// <returns></returns>
        public PriceLine PriceLine(Data.IDataSeries input)
        {
            if (cachePriceLine != null)
                for (int idx = 0; idx < cachePriceLine.Length; idx++)
                    if (cachePriceLine[idx].EqualsInput(input))
                        return cachePriceLine[idx];

            lock (checkPriceLine)
            {
                if (cachePriceLine != null)
                    for (int idx = 0; idx < cachePriceLine.Length; idx++)
                        if (cachePriceLine[idx].EqualsInput(input))
                            return cachePriceLine[idx];

                PriceLine indicator = new PriceLine();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                Indicators.Add(indicator);
                indicator.SetUp();

                PriceLine[] tmp = new PriceLine[cachePriceLine == null ? 1 : cachePriceLine.Length + 1];
                if (cachePriceLine != null)
                    cachePriceLine.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cachePriceLine = tmp;
                return indicator;
            }
        }
    }
}

// This namespace holds all market analyzer column definitions and is required. Do not change it.
namespace NinjaTrader.MarketAnalyzer
{
    public partial class Column : ColumnBase
    {
        /// <summary>
        /// Price Line
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.PriceLine PriceLine()
        {
            return _indicator.PriceLine(Input);
        }

        /// <summary>
        /// Price Line
        /// </summary>
        /// <returns></returns>
        public Indicator.PriceLine PriceLine(Data.IDataSeries input)
        {
            return _indicator.PriceLine(input);
        }
    }
}

// This namespace holds all strategies and is required. Do not change it.
namespace NinjaTrader.Strategy
{
    public partial class Strategy : StrategyBase
    {
        /// <summary>
        /// Price Line
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.PriceLine PriceLine()
        {
            return _indicator.PriceLine(Input);
        }

        /// <summary>
        /// Price Line
        /// </summary>
        /// <returns></returns>
        public Indicator.PriceLine PriceLine(Data.IDataSeries input)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.PriceLine(input);
        }
    }
}
#endregion
